////////////////////////////////////////////////////////////////////////////////
// Javascriptテンプレートエンジン(1ファイル実行版).
// Copyright (c) 2009 masahito suzuki, Inc. All Rights Reserved.
//
// jtemplate.jsを呼び出す場合には、bodyタグには<body style="display:none">として、
// bodyタグを非表示にする必要があります.
////////////////////////////////////////////////////////////////////////////////
JTemplate = {
    // リフレッシュ用実行スクリプトキャッシュ.
    _$ref$cache$_ : "",
    _isIE : /*@cc_on!@*/false,
    // 初期処理.
    _init : function() {
        document.body.style.display="none" ;
        document.body.innerHTML = JTemplate._execution( document.body.innerHTML )
        document.body.style.display="block" ;
    },
    // 処理実行.
    _execution : function( aval ) {
        if( JTemplate._indexOfCote( aval,"#include" ) != -1 ) {
            aval = JTemplate._include( aval ) ;
        }
        if( JTemplate._indexOfCote( aval,"[@" ) != -1 && JTemplate._indexOfCote( aval,"@]" ) != -1 ) {
            var s = JTemplate._readScript( aval ) ;
            JTemplate._convert( s ) ;
            if( typeof( s[0] ) == "string" && s[0].length > 0 ) {
                JTemplate._innerJS( "_jtemplate_script_header",s[0] ) ;
            }
            JTemplate._$ref$cache$_ = s[1] ;
            s = null ;
            return (new Function( JTemplate._$ref$cache$_ ))() ;
        }
        else if( JTemplate._indexOfCote( aval,"#script" ) != -1 && JTemplate._indexOfCote( aval,"#/script" ) != -1 ) {
            JTemplate._$ref$cache$_ = "" ;
            return s ;
        }
        JTemplate._$ref$cache$_ = "" ;
        return aval ;
    },
    // include情報を抽出.
    _include : function( aval ) {
        var b = 0 ;
        var p,x,y ;
        var ret = "" ;
        var spnId = 0 ;
        while( true ) {
            p = JTemplate._indexOfCote( aval,"#include",b ) ;
            if( p == -1 ||
                !JTemplate._checkString( aval,"(",p+7 ) ||
                (x = JTemplate._indexOfCote( aval,"(",p )) == -1 ||
                (y = JTemplate._endPar( aval,2,x )) == -1 ) {
                ret += aval.substring( b ) ;
                break ;
            }
            ret += aval.substring( b,p ) ;
            ret += "[@=JTemplate.connect" + aval.substring( x,y+1 ) + "@]\n" ;
            b = y + 1 ;
        }
        return ret ;
    },
    // script情報を抽出.
    _readScript : function( aval ) {
        var script = "" ;
        var s,e ;
        while( true ) {
            s = JTemplate._indexOfCote( aval,"#script" ) ;
            if( s == -1 ) {
                break ;
            }
            e = JTemplate._indexOfCote( aval,"#/script",s+7 ) ;
            if( e == -1 ) {
                break ;
            }
            script += "\n" ;
            script += aval.substring( s+7,e ) ;
            aval = aval.substring( 0,s ) + aval.substring( e+8 ) ;
        }
        var b = 0 ;
        var p ;
        var sc = "" ;
        while( true ) {
            var p = JTemplate._indexOfCote( script,"}",b ) ;
            if( p == -1 ) {
                sc += script.substring( b ) ;
                break ;
            }
            if( !JTemplate._checkString( script,";",p ) ) {
                sc += script.substring( b,p + 1 ) + " ;" ;
            }
            else {
                sc += script.substring( b,p + 1 ) ;
            }
            b = p + 1 ;
        }
        script = sc ;
        sc = null ;
        return new Array(script,aval) ;
    },
    // テンプレートをJavascriptに変換.
    _convert : function( v ) {
        var buf = "" ;
        buf += "var _$res = \"\";\n" ;
        var str = v[ 1 ] ;
        v[ 1 ] = null ;
        var s,e,ss ;
        var p = 0 ;
        while( true ) {
            s = JTemplate._indexOfCote( str,"[@",p ) ;
            if( s == -1 ) {
                buf += "_$res += \"" + JTemplate._addCote( str.substring( p ) ) + "\";\n" ;
                break ;
            }
            ss = JTemplate._indexOfCote( str,"[@",s+2 ) ;
            e = JTemplate._indexOfCote( str,"@]",s+2 ) ;
            if( e == -1 ) {
                buf += "_$res += \"" + JTemplate._addCote( str.substring( p ) ) + "\";\n" ;
                break ;
            }
            else if( ss != -1 && ss < e ) {
                buf += "_$res += \"" + JTemplate._addCote( str.substring( p,ss+2 ) ) + "\";\n" ;
                p = ss+2 ;
            }
            else {
                buf += "_$res += \"" + JTemplate._addCote( str.substring( p,s ) ) + "\";\n" ;
                if( str.charAt( s+2 ) == "=" ) {
                    buf += "_$res += " + str.substring( s+3,e ) + ";\n" ;
                }
                else {
                    buf += str.substring( s+2,e ) + ";\n" ;
                }
                p = e+2 ;
            }
        }
        v[ 1 ] = buf + "\nreturn _$res;" ;
        return null ;
    },
    // コーテーション付加.
    _addCote : function( html ) {
        html = JTemplate._trim( html ) ;
        var yen = false ;
        if( html.indexOf( "\\\\" ) != -1 ) {
            html = JTemplate._changeString( html,"\\\\","*@_double^cote_@*" ) ;
            yen = true ;
        }
        html = JTemplate._indentCote( html,0,true ) ;
        html = JTemplate._changeString( html,"\r","\\r" ) ;
        html = JTemplate._changeString( html,"\n","\\n" ) ;
        html = JTemplate._changeString( html,"\t","\\t" ) ;
        if( yen ) {
            html = JTemplate._changeString( html,"*@_double^cote_@*","\\\\\\\\" ) ;
        }
        return html ;
    },
    // javascriptをInner化.
    _innerJS : function( id,value ) {
        var old = document.getElementById( id ) ;
        if( old != null && old != undefined ) {
            var up = old.parentNode;
            up.removeChild( old ) ;
        }
        var heads = document.getElementsByTagName("head");
        if( heads != null && heads != undefined ) {
            var script = document.createElement("script");
            script.setAttribute("type", "text/javascript");
            script.setAttribute("language", "javascript");
            script.setAttribute("id", id);
            value = JTemplate._trim( value ) ;
            if( JTemplate._isIE ) {
                script.text = value ;
            }
            else {
                script.appendChild(document.createTextNode(value)) ;
            }
            heads[heads.length-1].appendChild( script ) ;
        }
    },
    // コーテーションを検出しないIndexOf.
    _indexOfCote : function( base,cc,off ) {
        if( off == undefined || off == null ) {
            off = 0 ;
        }
        var len = base.length ;
        var cote = -1 ;
        var cs = cc.charAt(0) ;
        var cLen = cc.length ;
        var bef = 0 ;
        var yenFlag = false ;
        var c = null ;
        var res = null ;
        for( var i = off ; i < len ; i ++ ) {
            c = base.charAt( i ) ;
            if( cote != -1 ) {
                if( bef != '\\' && c == cote ) {
                    yenFlag = false ;
                    cote = -1 ;
                }
                else if( c == '\\' && bef == '\\' ) {
                    yenFlag = true ;
                }
                else {
                    yenFlag = false ;
                }
            }
            else {
                if( bef != '\\' && ( c == '\'' || c == '\"' ) ) {
                    cote = c ;
                }
                else if( c == cs ) {
                    res = true ;
                    for( var j = 1 ; j < cLen ; j ++ ) {
                        if( i + j >= len || cc.charAt( j ) != base.charAt( i + j ) ) {
                            res = false ;
                            break ;
                        }
                    }
                    if( res == true ) {
                        return i ;
                    }
                }
            }
            if( yenFlag ) {
                yenFlag = false ;
                bef = 0 ;
            }
            else {
                bef = c ;
            }
        }
        return -1 ;
    },
    // 指定位置から、スペース／改行／タブを除いた指定文字列が存在するかチェック.
    _checkString : function( string,code,index ) {
        var len = string.length ;
        var c ;
        for( var i = index+1 ; i < len ; i ++ ) {
            c = string.charAt( i ) ;
            if( c == ' ' || c == '\r' || c == '\n' || c == '\t' ) {
                continue ;
            }
            else if( c == code ) {
                return true ;
            }
            else {
                return false ;
            }
        }
        return true ;
    },
    // コーテーション付加.
    _indentCote : function( string,off,dc ) {
        if( string == undefined || string == null || string.length <= 0 ) {
            return "" ;
        }
        var cote = '\"' ;
        if( !dc ) {
            cote = '\'' ;
        }
        if( string.indexOf( cote ) != -1 ) {
            var yenCount = 0 ;
            var indNo = off ;
            var len = string.length ;
            var buf = "" ;
            var stack = new JTemplate._StackInfo() ;
            var c,decFlag,yenLen,j ;
            for( var i = 0 ; i < len ; i ++ ) {
                c = string.charAt( i ) ;
                if( c == cote ) {
                    decFlag = false ;
                    if( stack.size() > 0 && stack.peek() >= yenCount ) {
                        if( stack.peek() > yenCount ) {
                            stack.pop() ;
                            indNo -- ;
                            decFlag = false ;
                        }
                        else {
                            stack.pop() ;
                            decFlag = true ;
                        }
                    }
                    else {
                        stack.push( yenCount ) ;
                        indNo ++ ;
                    }
                    yenLen = (2<<(indNo-1))-1 ;
                    for( j = 0 ; j < yenLen ; j ++ ) {
                        buf += "\\" ;
                    }
                    buf += cote ;
                    yenCount = 0 ;
                    if( decFlag ) {
                        indNo -- ;
                    }
                }
                else if( c == '\\' ) {
                    yenCount ++ ;
                }
                else {
                    if( yenCount > 0 ) {
                        for( j = 0 ; j < yenCount ; j ++ ) {
                            buf += "\\" ;
                        }
                        yenCount = 0 ;
                    }
                    buf += c ;
                }
            }
            return buf ;
        }
        return string ;
    },
    // 括弧終端取得.
    _endPar : function( string,type,index ) {
        var s,e ;
        switch( type ) {
            case 0 : // {
                s = "{" ; e = "}" ; break ;
            case 1 : // [
                s = "[" ; e = "]" ; break ;
            case 2 : // (
                s = "(" ; e = ")" ; break ;
            case 3 : // <
                s = "<" ; e = ">" ; break ;
            default :
                return -1 ;
        }
        if( string.charAt( index ) != s ) {
            return -1 ;
        }
        var cote = 0 ;
        var cnt = 1 ;
        var len = string.length ;
        var c ;
        for( var i = index + 1 ; i < len ; i ++ ) {
            c = string.charAt( i ) ;
            if( cote != 0 ) {
                if( cote == c ) {
                    cote = 0 ;
                }
            }
            else {
                if( c == "\"" || c == "\'" ) {
                    cote = c ;
                    continue ;
                }
                if( c == s ) {
                    cnt ++ ;
                }
                else if( c == e ) {
                    cnt -- ;
                }
                if( cnt <= 0 ) {
                    return i ;
                }
            }
        }
        return -1 ;
    },
    // 文字列を置き換える.
    _changeString : function( base,src,dest ) {
        if( base == undefined || base == null ||
            src == undefined || src == null ||
            dest == undefined || dest == null ) {
            return "" ;
        }
        var pnt;
        var end;
        var buf = "";
        var srcLen = src.length ;
        pnt = base.indexOf(src);
        if (pnt == -1) {
            return base;
        } else if (pnt == 0) {
            buf += dest ;
            end = srcLen;
        } else {
            buf += base.substring(0, pnt);
            buf += dest;
            end = pnt + srcLen;
        }
        for (pnt += srcLen;;) {
            if ((pnt = base.indexOf(src, pnt)) == -1) {
                buf += base.substring(end);
                break;
            }
            if (pnt == end) {
                buf += dest;
            } else {
                buf += base.substring(end, pnt);
                buf += dest;
            }
            end = pnt + srcLen;
            pnt += srcLen;
        }
        return buf ;
    },
    // 前後内容を除外.
    _trim : function( string ) {
        var s = 0 ;
        var e = -1 ;
        var len = string.length ;
        var sFlg = false ;
        var c = null ;
        for( var i = 0 ; i < len ; i ++ ) {
            c = string.charAt( i ) ;
            if( c != ' '  && c != '　' && c != '\r' && c != '\n' && c != '\t' ) {
                s = i ;
                break ;
            }
            sFlg = true ;
        }
        e = len-1 ;
        var eFlg = false ;
        for( var i = len-1 ; i >= 0 ; i -- ) {
            c = string.charAt( i ) ;
            if( c != ' '  && c != '　' && c != '\r' && c != '\n' && c != '\t' ) {
                e = i ;
                break ;
            }
            eFlg = true ;
        }
        if( sFlg == true && eFlg == true ) {
            return " " + string.substring( s,e+1 ) + " " ;
        }
        else if( sFlg == true ) {
            return " " + string.substring( s ) ;
        }
        else if( eFlg == true ) {
            return string.substring( 0,e+1 ) + " " ;
        }
        return string ;
    },
    // stack.
    _StackInfo : function() {
        this.cell = null ;
        this.count = 0 ;
        this.clear = function() {
            this.cell = null ;
        } ;
        this.push = function(object) {
            var nw = new Array( 2 ) ;
            nw[ 0 ] = object;
            nw[ 1 ] = this.cell;
            this.cell = nw;
            this.count ++ ;
        } ;
        this.pop = function() {
            if( this.cell == null ) {
                return null ;
            }
            var ret = this.cell[ 0 ] ;
            this.cell = this.cell[ 1 ] ;
            this.count -- ;
            return ret ;
        } ;
        this.peek = function() {
            if( this.cell == null ) {
                return null ;
            }
            return this.cell[ 0 ] ;
        } ;
        this.size = function() {
            return this.count ;
        } ;
    },
    // Ajax(GET)実行.
    connect : function( url ) {
        // Ajaxオブジェクトを生成.
        var ajx = null ;
        if(window.ActiveXObject) {
            try {
                ajx = new ActiveXObject("Msxml2.XMLHTTP");
            } catch (e) {
                ajx = null ;
            }
            if( ajx == null || ajx == undefined ) {
                try {
                    ajx = new ActiveXObject("Microsoft.XMLHTTP");
                } catch (e) {
                    ajx = null;
                }
            }
        }
        else if(window.XMLHttpRequest) {
            ajx = new XMLHttpRequest();
        }
        if( ajx == null || ajx == undefined ) {
            ajx = new XMLHttpRequest();
            if( ajx == null || ajx == undefined ) {
                ajx = null ;
            }
        }
        if( ajx == null || ajx == undefined ) {
            return "" ;
        }
        if( url.indexOf( "?" ) != -1 ) {
            url += "&t=" + (new Date().getTime()) ;
        }
        else {
            url += "?t=" + (new Date().getTime()) ;
        }
        ajx.open("GET",url,false) ;
        ajx.send( null ) ;
        var result = ajx.responseText ;
        try {
            ajx.abort() ;
        } catch( e ) {
        }
        ajx = null ;
        return result ;
    },
    // jtemplate形式をロード.
    load : function( val ) {
        JTemplate._innerJS( "_jtemplate_script_header","" ) ;
        document.body.style.display="none" ;
        document.body.innerHTML = JTemplate._execution( val ) ;
        document.body.style.display="block" ;
    },
    // リフレッシュ処理.
    reflesh : function() {
        if( typeof( JTemplate._$ref$cache$_ ) == "string" && JTemplate._$ref$cache$_.length > 0 ) {
            document.body.innerHTML = (new Function( JTemplate._$ref$cache$_ ))() ;
        }
    }
}

// 開始イベント登録.
if(window.attachEvent) {
    //ie
    window.attachEvent("onload", JTemplate._init);
} else if(window.addEventListener) {
    //firefox..etc.
    window.addEventListener("load", JTemplate._init, true);
}
